Subject: Re: Coping with the pull-before-you-push model

From: Joshua Jensen <[email-masked]>
Date: Tue, 14 Sep 2010 09:51:22 -0600

----- Original Message -----
From: Theodore Tso
Date: 9/14/2010 6:12 AM
> On Sep 14, 2010, at 12:47 AM, Joshua Jensen wrote:
>>> Bear in mind that you can still shift to a maintainer model, but keep
>>> the maintainer automated. That is, you can queue up "to-pull" heads, and
>>> then have an automated process pull them one by one and do some basic QA
>>> (does it merge, does it build, does it pass automated tests, etc). Which
>> Do you know of any existing software that does this?  This may be ideal in the short ter
> Our workflow at $WORK involves pushing changes to gerrit to various "effort branches", and then once they are approved, we have a "Mergitator" script that will attempt to merge the effort branch with the merged master branch, and then attempt to do a build.  If the build succeeds, then the changes will get pushed back to the publically visible merged master branch, and then the Mergitator will move on to the next effort branch that requires merging.   If there is a merge conflict, the Mergitator will refuse the merge, and then give instructions on how to fix up the tree to avoid merge conflicts.
>
How does the integration with Gerrit work here?  The only thing that 
comes to mind is that you do something like:

git push gerrit HEAD:refs/for/merged-master

Then the approvals are done.  Afterward, Gerrit merges to the 
merged-master branch.

I would suppose an external script is performing regular fetches.  When 
it sees new code, it builds.

No, this can't be right, but I'll leave my incorrect workflow here.
> So this probably doesn't help you since I suspect you meant to ask the question, "do you know of any existing publically available software", but I can tell you that it certainly can be done, and that software exists.  Making it be software which is useful and usable to you would definitely take more work...
It's the branch queueing issue that is my current hang up.  Gerrit's 
method is slick, but that won't work outside of JGit.  I'm not opposed 
to JGit; I just haven't touched Java in years.

So, perhaps, a web interface where the branch owner selects the (pushed 
to central server) branch name that is ready to go.  A merge is 
attempted.  If it succeeds, great.  If it fails, then the merge is reset?

Josh